// 
// Parallel Computing, DCC/FCUP
// 
// 
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <limits.h>

typedef struct {
  int min;
  int* v;
  // TODO: add other necessary fields 

} shared_data_t;

shared_data_t sd; // shared data global variable.

// Sequential procedure.
int vector_min(int* v, int n) {
  int min = INT_MAX;
  for (int i=0; i < n; i++) {
    if (v[i] < min) {
      min = v[i];
    }
  }
  return min;
}

void* do_work(void* arg) {
  // TODO 
  // long rank = (long) arg;
  // int* my_u = ... ; 
  // int my_n = ...; 

  return 0; 
}

// Calculate min of vector using n_threads,
// including calling thread (the "manager" thread).
int parallel_vector_min(int* u, int n, int n_threads) {

  pthread_t* vth = (pthread_t*) malloc((n_threads-1) * sizeof(pthread_t));

  // TODO initialize sd
  // ...

  for (long rank =  1; rank < n_threads; rank++) {
    pthread_create(&vth[rank-1], NULL, &do_work, (void*) rank);
  }

  do_work((void*) 0); 

  for (long rank =  1; rank < n_threads; rank++) {
    pthread_join(vth[rank-1], NULL); 
  }
  // TODO tear-down any sd resources
  // ...

  free(vth);
  return sd.min;
}

int main(int argc, char** argv) {
  // Parse arguments
  --argc; ++argv;

  if (argc != 2) {
    printf("Usage: min_vector <array size> <threads>\n");
    return 1;
  }
  
  // The repetitions parameter is used for benchmarking purposes only.
  int n           = atoi(argv[0]),
      n_threads   = atoi(argv[1]);

  // Build a random vectors
  int *v = malloc(n * sizeof(int));
  for (int i = 0; i < n; i++) {
     v[i] = - n + rand() % (2 * n + 1);
  }

  if (n <= 10) { 
    printf("v: \n");
    for (int i = 0; i < 10; i++) {
      printf("  %2d -> %d\n", i, v[i]);
    }
  }

  int result = parallel_vector_min(v, n, n_threads);

  printf("min(v) = %d\n", result);

  // Clean up
  free(v);
  return 0; 
}
