// 
// Parallel Computing, DCC/FCUP
// 
// 
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <limits.h>

int vector_min(int* v, int n) {
  // TODO paralelize
  int min = INT_MAX;
  for (int i=0; i < n; i++) {
    if (v[i] < min) {
      min = v[i];
    }
  }
  return min;
}

int main(int argc, char** argv) {
  // Parse arguments
  --argc; ++argv;

  if (argc != 2) {
    printf("Usage: min_vector <array size> <threads>\n");
    return 1;
  }
  
  // The repetitions parameter is used for benchmarking purposes only.
  int n           = atoi(argv[0]),
      n_threads   = atoi(argv[1]);

  omp_set_num_threads(n_threads);
  // Build a random vectors
  int *v = malloc(n * sizeof(int));
  for (int i = 0; i < n; i++) {
     v[i] = - n + rand() % (2 * n + 1);
  }

  if (n <= 10) { 
    printf("v: \n");
    for (int i = 0; i < 10; i++) {
      printf("  %2d -> %d\n", i, v[i]);
    }
  }

  int result = vector_min(v, n);

  printf("min(v) = %d\n", result);

  // Clean up
  free(v);
  return 0; 
}
