
#include <stdio.h>
#include <omp.h>

#define N 64

int main(int argc, char** argv) {
  int a[N] = { 0 }, i;
  
  #pragma omp parallel for \
          private(a) \
          num_threads(N) 
  for (i = 0; i < N; i++) a[i] = i; 

  int sum = 1;
  #pragma omp parallel for \
          num_threads(N) \
          reduction(+:sum)
  for (i = 0; i < N; i++) sum += a[i]; 

  int expected_sum = 0;
  for (i = 0; i < N; i ++) {
    if (a[i] != i)  {
      printf("Unexpected value: a[%d] = %d !\n", i, a[i]);
    }
    expected_sum += i;
  }
  if (sum != expected_sum) {
    printf("Invalid sum: %d! Expected %d!\n", sum, expected_sum);
  }
  return 0;
}
